/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * 根据Apache License, Version 2.0（以下简称“许可证”）授权；
 * 除非遵守许可证，否则不得使用此文件。
 * 你可以在以下网址获得许可证的副本：
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * 除非适用法律要求或书面同意，否则按“原样”提供软件
 * 在许可证下分发，不附带任何明示或暗示的保证或条件。
 * 请参阅许可证，了解有关权限和限制的具体语言。
 */

package net.micode.notes.gtask.remote;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.os.AsyncTask;

import net.micode.notes.R;
import net.micode.notes.ui.NotesListActivity;
import net.micode.notes.ui.NotesPreferenceActivity;

// 异步任务类，用于执行GTask同步操作
public class GTaskASyncTask extends AsyncTask<Void, String, Integer> {

    // 定义GTASK同步通知的ID
    private static int GTASK_SYNC_NOTIFICATION_ID = 5234235;

    // 定义完成监听接口
    public interface OnCompleteListener {
        void onComplete();
    }

    // 上下文对象
    private Context mContext;
    // 通知管理器
    private NotificationManager mNotifiManager;
    // 任务管理器
    private GTaskManager mTaskManager;
    // 完成监听器
    private OnCompleteListener mOnCompleteListener;

    // 构造函数，初始化上下文、通知管理器、任务管理器和完成监听器
    public GTaskASyncTask(Context context, OnCompleteListener listener) {
        mContext = context;
        mOnCompleteListener = listener;
        mNotifiManager = (NotificationManager) mContext
                .getSystemService(Context.NOTIFICATION_SERVICE);
        mTaskManager = GTaskManager.getInstance();
    }

    // 取消同步的方法
    public void cancelSync() {
        mTaskManager.cancelSync();
    }

    // 发布进度消息的方法
    public void publishProgess(String message) {
        publishProgress(new String[] {
                message
        });
    }

    // 显示通知的方法
    private void showNotification(int tickerId, String content) {
        // 创建通知对象
        Notification notification = new Notification(R.drawable.notification, mContext
                .getString(tickerId), System.currentTimeMillis());
        notification.defaults = Notification.DEFAULT_LIGHTS;
        notification.flags = Notification.FLAG_AUTO_CANCEL;
        // 根据tickerId创建不同的PendingIntent
        PendingIntent pendingIntent;
        if (tickerId != R.string.ticker_success) {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesPreferenceActivity.class), 0);
        } else {
            pendingIntent = PendingIntent.getActivity(mContext, 0, new Intent(mContext,
                    NotesListActivity.class), 0);
        }
        // 设置通知的最新事件信息
        notification.setLatestEventInfo(mContext, mContext.getString(R.string.app_name), content,
                pendingIntent);
        // 发送通知
        mNotifiManager.notify(GTASK_SYNC_NOTIFICATION_ID, notification);
    }

    // 后台执行同步操作的方法
    @Override
    protected Integer doInBackground(Void... unused) {
        publishProgess(mContext.getString(R.string.sync_progress_login, NotesPreferenceActivity
                .getSyncAccountName(mContext)));
        return mTaskManager.sync(mContext, this);
    }

    // 更新进度的方法
    @Override
    protected void onProgressUpdate(String... progress) {
        showNotification(R.string.ticker_syncing, progress[0]);
        if (mContext instanceof GTaskSyncService) {
            ((GTaskSyncService) mContext).sendBroadcast(progress[0]);
        }
    }

    // 执行完毕后的方法
    @Override
    protected void onPostExecute(Integer result) {
        // 根据结果展示不同的通知
        if (result == GTaskManager.STATE_SUCCESS) {
            showNotification(R.string.ticker_success, mContext.getString(
                    R.string.success_sync_account, mTaskManager.getSyncAccount()));
            NotesPreferenceActivity.setLastSyncTime(mContext, System.currentTimeMillis());
        } else if (result == GTaskManager.STATE_NETWORK_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_network));
        } else if (result == GTaskManager.STATE_INTERNAL_ERROR) {
            showNotification(R.string.ticker_fail, mContext.getString(R.string.error_sync_internal));
        } else if (result == GTaskManager.STATE_SYNC_CANCELLED) {
            showNotification(R.string.ticker_cancel, mContext
                    .getString(R.string.error_sync_cancelled));
        }
        // 如果存在完成监听器，则通知监听器任务完成
        if (mOnCompleteListener != null) {
            new Thread(new Runnable() {

                public void run() {
                    mOnCompleteListener.onComplete();
                }
            }).start();
        }
    }
}